Attribute VB_Name = "GdiPlus"
Option Explicit

Public Enum GpStatus
    Ok = 0
    GenericError = 1
    InvalidParameter = 2
    OutOfMemory = 3
    ObjectBusy = 4
    InsufficientBuffer = 5
    NotImplemented = 6
    Win32Error = 7
    WrongState = 8
    Aborted = 9
    FileNotFound = 10
    ValueOverflow = 11
    AccessDenied = 12
    UnknownImageFormat = 13
    FontFamilyNotFound = 14
    FontStyleNotFound = 15
    NotTrueTypeFont = 16
    UnsupportedGdiplusVersion = 17
    GdiplusNotInitialized = 18
    PropertyNotFound = 19
    PropertyNotSupported = 20
End Enum


Public Enum SmoothingMode
    SmoothingModeInvalid = -1
    SmoothingModeDefault = 0
    SmoothingModeHighSpeed = 1
    SmoothingModeHighQuality = 2
    SmoothingModeNone
    SmoothingModeAntiAlias
End Enum

Public Enum PixelOffsetMode
    PixelOffsetModeInvalid = -1
    PixelOffsetModeDefault = 0
    PixelOffsetModeHighSpeed = 1
    PixelOffsetModeHighQuality = 2
    PixelOffsetModeNone
    PixelOffsetModeHalf
End Enum


Public Type GdiplusStartupInput
    GdiplusVersion As Long
    DebugEventCallback As Long
    SuppressBackgroundThread As Long
    SuppressExternalCodecs As Long
End Type

Public Type RECTF
    Left As Single
    Top As Single
    Right As Single
    Bottom As Single
End Type



Public Declare Function GdiplusStartup Lib "gdiplus" (ByRef token As OLE_HANDLE, ByRef inputbuf As GdiplusStartupInput, Optional ByVal outputbuf As Long = 0) As GpStatus
Public Declare Sub GdiplusShutdown Lib "gdiplus" (ByVal token As OLE_HANDLE)

Public Declare Function GdipCreateFromHDC Lib "gdiplus" (ByVal hDC As OLE_HANDLE, ByRef graphics As OLE_HANDLE) As GpStatus
Public Declare Function GdipCreateFontFromDC Lib "gdiplus" (ByVal hDC As OLE_HANDLE, ByRef createdfont As OLE_HANDLE) As GpStatus
Public Declare Function GdipCreateSolidFill Lib "gdiplus" (ByVal argb As Long, ByRef brush As OLE_HANDLE) As GpStatus
Public Declare Function GdipStringFormatGetGenericDefault Lib "gdiplus" (ByRef StringFormat As OLE_HANDLE) As GpStatus
Public Declare Function GdipSetSmoothingMode Lib "gdiplus" (ByVal graphics As OLE_HANDLE, ByVal SmoothingMd As SmoothingMode) As GpStatus
Public Declare Function GdipSetPixelOffsetMode Lib "gdiplus" (ByVal graphics As OLE_HANDLE, ByVal PixOffsetMode As PixelOffsetMode) As GpStatus
Public Declare Function GdipDrawString Lib "gdiplus" (ByVal graphics As OLE_HANDLE, ByRef str As Byte, ByVal length As Long, ByVal thefont As OLE_HANDLE, ByRef layoutRect As RECTF, ByVal StringFormat As OLE_HANDLE, ByVal brush As OLE_HANDLE) As GpStatus

Public Declare Function GdipDeleteBrush Lib "gdiplus" (ByVal brush As OLE_HANDLE) As GpStatus
Public Declare Function GdipDeleteFont Lib "gdiplus" (ByVal curFont As OLE_HANDLE) As GpStatus
Public Declare Function GdipDeleteGraphics Lib "gdiplus" (ByVal graphics As OLE_HANDLE) As GpStatus

